-- HivemindTokens - Released during BFA

local HivemindTokens = ...
local frame = CreateFrame("Frame")

HivemindTokens = LibStub("AceAddon-3.0"):NewAddon("HivemindTokens", "AceConsole-3.0", "AceEvent-3.0")

local fTokenFound = "0"
local optionsFrame = ""
HivemindTokens.fTokens = {
	[0] = "Tokens 1",
	[1] = "Tokens 2",
	[2] = "Tokens 3",
	[3] = "Tokens 4",
	[4] = "Tokens 5",
	[5] = "Tokens 6",
	[6] = "Tokens 7",
	[7] = "Tokens 8",
	[8] = "Tokens 9",
	[9] = "Tokens 10",
	[10] = "Tokens 11",
	[11] = "Tokens 12",
	[12] = "Tokens 13",
	[13] = "Tokens 14",
	[14] = "Tokens 15",
	[15] = "Tokens 16",
	[16] = "Tokens 17",
	[17] = "Tokens 18",
	[18] = "Tokens 19",
	[19] = "Tokens 20",
	[20] = "Tokens 21",
	[21] = "Tokens 22",
	[22] = "Tokens 23",
	[23] = "Red Monocle",
}

HivemindTokens.fTokenNum = {
	[0] = 500,
	[1] = 100,
	[2] = 50,
	[3] = 250,
	[4] = 10,
	[5] = 50,
	[6] = 80,
	[7] = 2,
	[8] = 4,
	[9] = 1,
	[10] = 2,
	[11] = 40,
	[12] = 5,
	[13] = 300,
	[14] = 30,
	[15] = 30,
	[16] = 3,
	[17] = 5,
	[18] = 1500,
	[19] = 300,
	[20] = 100,
	[21] = 20,
	[22] = 5,
	[23] = 1,
}

HivemindTokens.fTarMob = {
	[0] = "/target Sir Finley",
	[1] = "/target Volatile Violetscale",
	[2] = "/target Manta Stargazer",
	[3] = "/target Lil' Whaley",
	[4] = "/target Gloomy Bluefin",
	[5] = "/target Ol' Fishbreath",
	[6] = "/target Sir Finley",
	[7] = "/target Gloomy Bluefin",
	[8] = "/target Little Carp",
	[9] = "/target Volatile Violetscale",
	[10] = "/target Crimson Angerfish",
	[11] = "/target Manta Stargazer",
	[12] = "/target Sir Finley",
	[13] = "/target Sir Finley",
	[14] = "/target Ol' Fishbreath",
	[15] = "/target The Blackfish",
	[16] = "/target Volatile Violetscale",
	[17] = "/target Little Carp",
	[18] = "/target Sir Finley",
	[19] = "/target Lil' Whaley",
	[20] = "/target Ol' Fishbreath",
	[21] = "/target Crimson Anglerfish",
	[22] = "/target The Blackfish",
	[23] = "/target Sir Finley",
}

HivemindTokens.fSelMobName = {
	[0] = "Sir Finley = ",
	[1] = "Volatile Violetscale = ",
	[2] = "Manta Stargazer = ",
	[3] = "Lil' Whaley = ",
	[4] = "Gloomy Bluefin = ",
	[5] = "Ol' Fishbreath = ",
	[6] = "Sir Finley = ",
	[7] = "Gloomy Bluefin = ",
	[8] = "Little Carp = ",
	[9] = "Volatile Violetscale = ",
	[10] = "Crimson Angerfish = ",
	[11] = "Manta Stargazer = ",
	[12] = "Sir Finley = ",
	[13] = "Sir Finley = ",
	[14] = "Ol' Fishbreath = ",
	[15] = "The Blackfish = ",
	[16] = "Volatile Violetscale = ",
	[17] = "Little Carp = ",
	[18] = "Sir Finley = ",
	[19] = "Lil' Whaley = ",
	[20] = "Ol' Fishbreath = ",
	[21] = "Crimson Anglerfish = ",
	[22] = "The Blackfish = ",
	[23] = "Sir Finley = ",
}

HivemindTokens.fMobName = {
	"Sir Finley Mrrgglton",
	"Volatile Violetscale",
	"Manta Stargazer",
	"Lil' Whaley",
	"Gloomy Bluefin",
	"Ol' Fishbreath",
	"Little Carp",
	"Crimson Angerfish",
	"The Blackfish",
}

HivemindTokens.fTarMobName = {
	"/Target Sir Finley Mrrgglton",
	"/Target Volatile Violetscale",
	"/Target Manta Stargazer",
	"/Target Lil' Whaley",
	"/Target Gloomy Bluefin",
	"/Target Ol' Fishbreath",
	"/Target Little Carp",
	"/Target Crimson Angerfish",
	"/Target The Blackfish",
}

HivemindTokens.fLocations = {
	[0] = "/way Shimmering Expanse 44 20 Sir Finley/Seashell (500)",
	[1] = "/way Abyssal Depths 38 77 Volatile Violetscale/Cavity-Free Great Shark Tooth (100)",
	[2] = "/way Shimmering Expanse 53 22 Manta Stargazer/Razoreel Larva (50)",
	[3] = "/way Shimmering Expanse 69 47 Lil' Whaley/Well-Fed Doctor Fish (250)",
	[4] = "/way Abyssal Depths 65 42 Gloomy Bluefin/Freshly Molted Crab Skin (10)",
	[5] = "/way Kelp'thar Forest 60 59 Ol' Fishbreath/Glittergill Glitter (50)",
	[6] = "/way Shimmering Expanse 44 20 Sir Finley/Seashell (80)",
	[7] = "/way Abyssal Depths 65 42 Gloomy Bluefin/Giant Giant Toenail Clipping (2)",
	[8] = "/way Abyssal Depths 45 17 Little Carp/Makrura Eye (4)",
	[9] = "/way Abyssal Depths 38 77 Volatile Violetscale/Accidentally-Severed Seahorse Fin (1)",
	[10] = "/way Shimmering Expanse 53 88 Crimson Angerfish/Shiny Sea Serpent Scale (2)",
	[11] = "/way Shimmering Expanse 53 22 Manta Stargazer/Symbiotic Plankton (40)",
	[12] = "/way Shimmering Expanse 44 20 Sir Finley/Scintillating Murloc Skin Lotion (5)",
	[13] = "/way Shimmering Expanse 44 20 Sir Finley/Seashell (300)",
	[14] = "/way Kelp'thar Forest 60 59 Ol' Fishbreath/Vantus Black Squid Ink (30)",
	[15] = "/way Abyssal Depths 15 82 The Blackfish/Super Slick Eel Slime (30)",
	[16] = "/way Abyssal Depths 38 77 Volatile Violetscale/Rock-Encrusted Whelk Shell (3)",
	[17] = "/way Abyssal Depths 45 17 Little Carp/Potent Gastropod Gloop (5)",
	[18] = "/way Shimmering Expanse 44 20 Sir Finley/Seashell (1500)",
	[19] = "/way Shimmering Expanse 69 47 Lil' Whaley/Very Pretty Coral (300)",
	[20] = "/way Kelp'thar Forest 60 59 Ol' Fishbreath/Iridescent Shimmeray Skin (100)",
	[21] = "/way Shimmering Expanse 53 88 Crimson Anglerfish/Luxurious Luxscale Scale (20)",
	[22] = "/way Abyssal Depths 15 82 The Blackfish/Captured Cavitation Bubble (5)",
	[23] = "/way Shimmering Expanse 44 20 Sir Finley/Red Monocle",
}

HivemindTokens.fReport = {
	[0] = "Wapoint added! Get your Seashell (500)",
	[1] = "Wapoint added! Get your Cavity-Free Great Shark Tooth (100)",
	[2] = "Wapoint added! Get your Razoreel Larva (50)",
	[3] = "Wapoint added! Get your Well-Fed Doctor Fish (250)",
	[4] = "Wapoint added! Get your Freshly Molted Crab Skin (10)",
	[5] = "Wapoint added! Get your Glittergill Glitter (50)",
	[6] = "Wapoint added! Get your Seashell (80)",
	[7] = "Wapoint added! Get your Giant Giant Toenail Clipping (2)",
	[8] = "Wapoint added! Get your Makrura Eye (4)",
	[9] = "Wapoint added! Get your Accidentally-Severed Seahorse Fin (1)",
	[10] = "Wapoint added! Get your Shiny Sea Serpent Scale (2)",
	[11] = "Wapoint added! Get your Symbiotic Plankton (40)",
	[12] = "Wapoint added! Get your Scintillating Murloc Skin Lotion (5)",
	[13] = "Wapoint added! Get your Seashell (300)",
	[14] = "Wapoint added! Get your Vantus Black Squid Ink (30)",
	[15] = "Wapoint added! Get your Super Slick Eel Slime (30)",
	[16] = "Wapoint added! Get your Rock-Encrusted Whelk Shell (3)",
	[17] = "Wapoint added! Get your Potent Gastropod Gloop (5)",
	[18] = "Wapoint added! Get your Seashell (1500)",
	[19] = "Wapoint added! Get your Very Pretty Coral (300)",
	[20] = "Wapoint added! Get your Iridescent Shimmeray Skin (100)",
	[21] = "Wapoint added! Get your Luxurious Luxscale Scale (20)",
	[22] = "Wapoint added! Get your Captured Cavitation Bubble (5)",
	[23] = "Wapoint added! Get your Red Monocle!",
}

HivemindTokens.fName = {
	[0] = "Seashell : ",
	[1] = "Cavity-Free Great Shark Tooth : ",
	[2] = "Razoreel Larva : ",
	[3] = "Well-Fed Doctor Fish : ",
	[4] = "Freshly Molted Crab Skin : ",
	[5] = "Glittergill Glitter : ",
	[6] = "Seashell : ",
	[7] = "Giant Giant Toenail Clipping : ",
	[8] = "Makrura Eye : ",
	[9] = "Accidentally-Severed Seahorse Fin : ",
	[10] = "Shiny Sea Serpent Scale : ",
	[11] = "Symbiotic Plankton : ",
	[12] = "Scintillating Murloc Skin Lotion : ",
	[13] = "Seashell : ",
	[14] = "Vantus Black Squid Ink : ",
	[15] = "Super Slick Eel Slime : ",
	[16] = "Rock-Encrusted Whelk Shell : ",
	[17] = "Potent Gastropod Gloop : ",
	[18] = "Seashell : ",
	[19] = "Very Pretty Coral : ",
	[20] = "Iridescent Shimmeray Skin : ",
	[21] = "Luxurious Luxscale Scale : ",
	[22] = "Captured Cavitation Bubble : ",
	[23] = "Sir Finley = Red Monocle : ",
}

local MyMinimap = {
        type = "launcher",
        text = "HivemindTokens",
        icon = "Interface\\Addons\\HivemindTokens\\Icons\\Hivemind",
        OnClick = function( f, button )
                      LibStub("AceConfigDialog-3.0"):Open("HivemindTokens")
                    GameTooltip:Hide()
                  end,
        OnTooltipShow = function( mt )
                          mt:AddDoubleLine( "HivemindTokens", Minimap.text )
                          mt:AddLine( "|cFFFFFFFFClick to open the the HivemindTokens interface.|r" )
                        end,
} 

HivemindTokens:RegisterChatCommand("mychat", "ChatCommand")

-- Show the GUI if no input is supplied, otherwise handle the chat input.
function HivemindTokens:ChatCommand(input)
  -- Assuming "MyOptions" is the appName of a valid options table
  if not input or input:trim() == "" then
    LibStub("AceConfigDialog-3.0"):Open("options")
  else
    LibStub("AceConfigCmd-3.0").HandleCommand(HivemindTokens, "mychat", "options", input)
  end
end

function RunSlashCmd(cmd)
	local slash, rest = cmd:match("^(%S+)%s*(.-)$")
	ChatFrame_ImportAllListsToHash()
	local handler = hash_SlashCmdList[slash:upper()]
	if handler then
		handler(rest)
	end
end

function HivemindTokens:RefreshVal()
	if HivemindTokens.DB.profile.minimap.seltest == 0 then
		local countBags = GetItemCount(156791)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 1 then
		local countBags = GetItemCount(156780)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 2 then
		local countBags = GetItemCount(156786)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 3 then
		local countBags = GetItemCount(156783)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 4 then
		local countBags = GetItemCount(156782)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 5 then
		local countBags = GetItemCount(156790)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 6 then
		local countBags = GetItemCount(156791)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 7 then
		local countBags = GetItemCount(156775)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 8 then
		local countBags = GetItemCount(156776)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 9 then
		local countBags = GetItemCount(156773)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 10 then
		local countBags = GetItemCount(156774)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 11 then
		local countBags = GetItemCount(156789)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 12 then
		local countBags = GetItemCount(156793)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 13 then
		local countBags = GetItemCount(156791)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 14 then
		local countBags = GetItemCount(156771)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 15 then
		local countBags = GetItemCount(156770)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 16 then
		local countBags = GetItemCount(156767)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 17 then
		local countBags = GetItemCount(156788)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 18 then
		local countBags = GetItemCount(156791)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 19 then
		local countBags = GetItemCount(156761)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 20 then
		local countBags = GetItemCount(156758)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 21 then
		local countBags = GetItemCount(156764)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	elseif HivemindTokens.DB.profile.minimap.seltest == 22 then
		local countBags = GetItemCount(156787)
		fTokenFound = "|cFF00FF00"..HivemindTokens.fSelMobName[HivemindTokens.DB.profile.minimap.seltest]..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]-countBags).."|r\n"
	end
	LibStub("AceConfigRegistry-3.0"):NotifyChange("HivemindTokens")
end

function HivemindTokens:GetSelVal(info)
	return self.DB.profile.minimap.seltest
end

function HivemindTokens:ResetWay()
	RunSlashCmd("/way reset all")
end

function HivemindTokens:TarNPC()
	TargetNPCFrame:Show()
end

StaticPopupDialogs["NECK_EQUIPED"] = {
  text = "|cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|cFFFF0000  Is Not Equiped!|h|r",
  button1 = "Equip",
  button2 = "Close",
  OnAccept = function()
      HivemindTokens:EquipTalisman()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

StaticPopupDialogs["NO_NECK"] = {
  text = "You do not have any |cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|h|r in your inventory or equiped! Go buy one!",
  button1 = "Close",
  OnAccept = function()
      -- do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindTokens:EquipTalisman()
	EquipItemByName(27944)
end

local TargetNPCFrame = CreateFrame("Frame","TargetNPCFrame", UIParent, "BasicFrameTemplate")
local SelectedNPC = "/Target Sir Finley Mrrgglton"

TargetNPCFrame:SetSize(160,120)
TargetNPCFrame:SetPoint("CENTER")
TargetNPCFrame:EnableMouse(true)
TargetNPCFrame:SetMovable(true)
TargetNPCFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 8, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
TargetNPCFrame:SetBackdropColor(0,0,0,1);
TargetNPCFrame:RegisterForDrag("LeftButton")
TargetNPCFrame:SetScript("OnDragStart",TargetNPCFrame.StartMoving)
TargetNPCFrame:SetScript("OnDragStop",TargetNPCFrame.StopMovingOrSizing)

TargetNPCFrame.button1 = CreateFrame("Button","TestButton1",TargetNPCFrame,"SecureActionButtonTemplate, SecureHandlerShowHideTemplate")
TargetNPCFrame.button1:SetSize(120,30)
TargetNPCFrame.button1:SetPoint("TOP",0,-40)
local ntex = TargetNPCFrame.button1:CreateTexture()
ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
ntex:SetTexCoord(0, 0.625, 0, 0.6875)
ntex:SetAllPoints()	
TargetNPCFrame.button1:SetNormalTexture(ntex)
TargetNPCFrame.button1:SetNormalFontObject("GameFontNormalSmall");
TargetNPCFrame.button1:SetText("Target NPC")
TargetNPCFrame.button1:SetAttribute("type1", "macro")
TargetNPCFrame.button1:SetAttribute("macrotext", SelectedNPC)
TargetNPCFrame.button1:HookScript("OnClick", function()
	if IsEquippedItem(27944) then
		SetRaidTarget("target",8)
	else
		if GetItemCount(27944) == 0 then
			StaticPopup_Show("NO_NECK")
		else
			StaticPopup_Show("NECK_EQUIPED")
		end
	end
end)

TargetNPCFrame.DropDown = CreateFrame("Frame",nil,TargetNPCFrame,"UIDropDownMenuTemplate")
TargetNPCFrame.DropDown:SetSize(100,22)
TargetNPCFrame.DropDown:SetPoint("TOP",0,-70)
TargetNPCFrame:Hide()

local function OnClick(self)
	UIDropDownMenu_SetSelectedID(TargetNPCFrame.DropDown, self:GetID())
	SelectedNPC = HivemindTokens.fTarMobName[self:GetID()]
	TargetNPCFrame.button1:SetAttribute("macrotext", SelectedNPC)
end

local function initialize(self, level)
	local info = UIDropDownMenu_CreateInfo()
	for k, v in pairs(HivemindTokens.fMobName) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
end

UIDropDownMenu_Initialize(TargetNPCFrame.DropDown , initialize)
UIDropDownMenu_SetWidth(TargetNPCFrame.DropDown , 100);
UIDropDownMenu_SetButtonWidth(TargetNPCFrame.DropDown , 124)
UIDropDownMenu_SetSelectedID(TargetNPCFrame.DropDown , 1)
UIDropDownMenu_JustifyText(TargetNPCFrame.DropDown , "LEFT")

function HivemindTokens:SetSelVal(info , newValue)
	self.DB.profile.minimap.seltest = newValue
	fTokenFound = "|cFF00FF00"..HivemindTokens.fName[HivemindTokens.DB.profile.minimap.seltest]..tostring(HivemindTokens.fTokenNum[HivemindTokens.DB.profile.minimap.seltest]).."|r\n"
	self:Print(HivemindTokens.fReport[self.DB.profile.minimap.seltest])
	RunSlashCmd(self.fLocations[self.DB.profile.minimap.seltest])
	HivemindTokens:RefreshVal()
	LibStub("LibDBIcon-1.0"):Refresh( "HivemindTokens", self.DB.profile.minimap )
end

function HivemindTokens:GetOptions()
  local options = {
    name = "HivemindTokens",
    handler = HivemindTokens,
    type = 'group',
    args = {
	    intro = {
		    order = 1,
			  type = "description",
			  name = "HivemindTokens wil count tokens for you.",
		  },
      qf = {
        order = 2,
        type = "input",
        name = "Tokens",
        desc = "Tokens progress!",
        usage = "Count the tokens for you!",
        get = "GetTokenFound",
        --set = "SetTokenFound",
        width = "full",
        multiline = 1,
		disabled = true,
      },
	  cl = {
        order = 3,
        type = "select",
        name = "TomTom coords",
        desc = "Click to set tomtom coord",
		values = self.fTokens,
		get = "GetSelVal",
        set = "SetSelVal",
      },
	  rw = {
		order = 4,
        type = "execute",
        name = "Reset Waypoints",
		desc = "Remove all waypoints from the map.",
		func = 'ResetWay',
      },
	  tm = {
		order = 5,
        type = "execute",
        name = "Target NPC",
		desc = "Target the current NPC and put a skull mark.",
		func = 'TarNPC',
      },
      mm = {
		order = 6,
        type = "toggle",
        name = "Hide Minimap Icon",
        desc = "If checked, the minimap icon will be hidden.",
        get = 'GetOption',
        set = 'SetOption',
      },
    },
  }
  return options
end
  
function HivemindTokens:SetOption( info, input)
    self.DB.profile.minimap.hide = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindTokens", self.DB.profile.minimap )
end
  
function HivemindTokens:GetOption( info)
    return self.DB.profile.minimap.hide            
end

function HivemindTokens:ClearVars(info)
    fQuestName = ""
    fQuestId = ""
    fQuestFound = ""
	fQuestNum = ""
end

function HivemindTokens:GetDefaults()
  local defaults = {
    profile = {
      minimap = { 
        hide = true,
      }
    },
  }  
  return defaults
end

-- Not using 
function HivemindTokens:TotalRefresh()
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindTokens", self.DB.profile.minimap )    
end

function HivemindTokens:OnInitialize()
    -- Called when the addon is loaded
    self.DB = LibStub( "AceDB-3.0" ):New( "HivemindTokensDB", self:GetDefaults() )

    self.Options = HivemindTokens:GetOptions()
	
	C_Timer.After(3, function()
	--HivemindTokens:OnFill()
	end)
	
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HivemindTokens", self.Options, {"ht"})
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("HivemindTokens", 350, 330)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HivemindTokens", "HivemindTokens")
    self:RegisterChatCommand("ht", function() LibStub("AceConfigDialog-3.0"):Open("HivemindTokens") end)
    
    LibStub("LibDataBroker-1.1"):NewDataObject("HivemindTokens", MyMinimap);
    LibStub("LibDBIcon-1.0"):Register("HivemindTokens", MyMinimap, self.DB);
end

function HivemindTokens:ChatCommand(input)
   if not input or input:trim() == "" then
       InterfaceOptionsFrame_OpenToCategory(optionsFrame)
   else     
        LibStub("AceConfigCmd-3.0"):HandleCommand("ht", input)
   end
end

function HivemindTokens:GetTokenFound(info)
    return fTokenFound
end

function HivemindTokens:SetTokenFound(info, newValue)
    fTokenFound = newValue
end

function HivemindTokens:OnEnable()
    -- Called when the addon is enabled
    if self.DB.profile.minimap.hide == true then
      self:Print("HivemindTokens enabled.  Minimap Icon is hidden.")
    else
      self:Print("HivemindTokens enabled.  Minimap Icon is shown.")
    end
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindTokens", self.DB.profile.minimap )
end

function HivemindTokens:OnDisable()
    -- Called when the addon is disabled
    self:Print("HivemindTokens disabled.")
end

frame:SetScript("OnEvent", function()
	HivemindTokens:RefreshVal()
end)

frame:RegisterEvent("BAG_UPDATE")
C_Timer.After(3, function() DEFAULT_CHAT_FRAME:AddMessage("|cff0083e8<HivemindTokens loaded!>|cffffff3aType /ht to open addon!|r") end)
